 /*
  	2010/06/09(Wed)
	sample.c version 1.0
	Programmed by KOYAMA Yoshiaki
 */

#include "iocs.h"
#include "library.h"

/*
	画像データ
*/
byte box[8][10] =  {
			{0xff, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0xff},			/* Box (セル) 枠 OR */
			{0x03, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x03},			
			{0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00},				 /* Box (セル) 枠消去	AND	*/
			{0xfc, 0xfd, 0xfd, 0xfd, 0xfd, 0xfd, 0xfd, 0xfd, 0xfd, 0xfc},			
			{0xff, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0xff},			/* 	Box (セル) 内消去	AND*/
			{0xff, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xff},		
			{0x00, 0xfe, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0xfe, 0x00},			/* Box (セル) 1ドット内側枠 */
			{0x00, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00}
		};	

/*
	セルの画像テータ
*/
byte data[15][8] = {
		{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},		/* 0  */		
		{0x00,0x00,0x04,0x02,0x7E,0x00,0x00,0x00},		/*  1 */		
		{0x00,0x00,0x64,0x52,0x4A,0x44,0x00,0x00},		/* 2*/		
		{0x00,0x00,0x22,0x4A,0x4A,0x36,0x00,0x00},		/* 3 */		
		{0x00,0x10,0x18,0x14,0x7E,0x10,0x00,0x00},		/*  4*/		
		{0x00,0x00,0x2E,0x4A,0x4A,0x32,0x00,0x00},		/*  5*/		
		{0x00,0x00,0x3C,0x4A,0x4A,0x32,0x00,0x00},		/*  6*/		
		{0x00,0x00,0x02,0x72,0x0A,0x06,0x00,0x00},		/*  7*/		
		{0x00,0x00,0x34,0x4A,0x4A,0x34,0x00,0x00},		/*  8*/		
		{0x00,0x08,0x3C,0x64,0x26,0x3C,0x10,0x00},		/*  mine */		
		{0x00,0x42,0x24,0x18,0x18,0x24,0x42,0x00},		/*  X */		
		{0x00,0x7E,0x42,0x5A,0x5A,0x42,0x7E,0x00},		/*  block */	
		{0x00,0x00,0x04,0x52,0x0a,0x04,0x00,0x00},		/*  ? */			
		{0x00,0x00,0x7e,0x0e,0x0e,0x0e,0x00,0x00},		/*  flag */	
		{0x00,0x08,0x3C,0x7c,0x3e,0x3c,0x10,0x00}		/* 爆発した地雷*/					
		};


byte wall[3][4] = {
			{0x0f, 0x0f, 0x0f, 0x0f},
			{0x0f, 0x0f, 0x0f, 0x0f},
			{0x8f, 0x8f, 0x8f, 0x8c}
		};

/*
	library.h

	#define X_SIZE		144
	#define	Y_SIZE		48

	#define X_LINE		24
	#define Y_LINE		6

	#define GPRINT_OR		  			0x01
	#define GPRINT_AND					0x00
	#define GPRINT_DRAW					0x02
	#define GPRINT_GRAM					0x04

*/
void main(void) {
	byte code;
	byte x, y;
	
	/*
		画面消去
	*/
	cls();
	
	/*
		仮想VRAM 消去 
		gprint、gprint8 を利用する場合、必ず必要
	*/
	initgvram();
	
	/* 数字の8を表示 */
	x = 0; y = 0;
	gprint8(x,  y,  8, data[8],  GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);			
	
	/* 数字の8を表示 */
	x = 123; y = 39;
	gprint8(x,  y,  8, data[8],  GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);			
	
	/*
		wall[3][4] を表示
	*/
	x = 123; y = 0;	
	gprint(x, y, 4,  3, wall[0], GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);
	
	x = 2*9;
	y = 3*9;
	
	/*
		交差しても描画できる
	*/
	gprint(x, y, 10,  2, box[0], GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);	
	gprint(x+5, y+5, 10,  2, box[0], GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);	
	
	gprint8(x+1,  y+1,  8, data[6],  GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);			
	
	setLocate(3,0);
	print("Push any key!");
	code = inkeyWait();
	
	/*
		box[4] ビットが立っていない部分だけ消去
	*/
	gprint(x, y, 10,  2, box[4], GPRINT_AND | GPRINT_DRAW | GPRINT_GRAM);	
	
	/*
		上で消去した部分に block を表示
	*/
	gprint8(x+1,  y+1,  8, data[11],  GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);			
	
	setLocate(3,0);
	print("Push any key!");
	
	setLocate(3,1);
	print("random()=");
	printByte(random() % 10); /* 0-9 の値を返す */
	
	code = inkeyWait();
	
	/*
		メモリに描画した内容を覚えている
	*/
	drawScreen();
	
	setLocate(3,0);
	print("Push any key!");
	
	code = inkeyWait();
	
}
